//  ** Revision History **
//  22-Jun-1992 (AH) Moved to PWB
//---------------------------------------------------------------------------
// ccInit.c
//---------------------------------------------------------------------------
// Custom Control DLL Initialization
//---------------------------------------------------------------------------

#define  NOCOMM
#include <windows.h>

#include <vbapi.h>
#include "eshslide.h"

//---------------------------------------------------------------------------
// External Variables & functions
//---------------------------------------------------------------------------
LONG FAR PASCAL _export AboutPopupWndProc(HWND hwnd, USHORT msg, USHORT wp, LONG lp);
LONG FAR PASCAL _export ColorPopupWndProc(HWND hwnd, USHORT msg, USHORT wp, LONG lp); 

extern MODEL modelHSlide;     // From hslide.h
extern MODELINFO modelinfoHSlide;
extern MODEL modelHSlide_Vb1;     // From vb1.h
extern MODELINFO modelinfoHSlide_Vb1;
extern MODEL modelHSlide_Vb1;     // From vb2.h
extern MODELINFO modelinfoHSlide_Vb2;

//---------------------------------------------------------------------------
// Global Variables
//---------------------------------------------------------------------------
HANDLE  hmodDLL;
WORD   	cVbxUsers = 0;
BOOL   	fDevTimeInited = FALSE;
HCTL    hctlDialog;
WORD    ipropDialog;
USHORT  VBVersion;
HBITMAP gSlideHScale;
HBITMAP gSlideHThumb;
HBITMAP gSlideHrightArrow;
HBITMAP gSlideHleftArrow;

//---------------------------------------------------------------------------
// Register custom control.
//      This routine is called by VB when the custom control DLL is
//      loaded for use.
//---------------------------------------------------------------------------

BOOL FAR PASCAL _export VBINITCC(USHORT usVersion, BOOL fRuntime)
{
    BOOL        rv;                           
#ifndef RUNTIMEVERSION
    WNDCLASS    EsColorclass; 
#endif    
    // Avoid warnings on unused (but required) formal parameters
    fRuntime  = fRuntime;
    VBVersion = usVersion;

	// Count the number of hosts using this VBX.  A host can be vb.exe,
    // any .exe compiled from vb which uses this custom control, or any
    // other program which loads and uses VBX files.
    ++cVbxUsers;
    
#ifdef RUNTIMEVERSION
	if (!fRuntime && !fDevTimeInited) {   
	MessageBox(NULL,(LPSTR)"This custom control can't be used in the design envirement. Use Design mode version.",
					(LPSTR)"EuroSource Buttons - Load Error", MB_ICONSTOP);
	VBSetErrorMessage(ERR_NotDesign, ERR_NotDesignStr);   
	return 0;
	}
#else             
     
     // Register ABOUT popup class if this is from the development environment.
    if (!fRuntime) {
	WNDCLASS    Aboutclass;

	Aboutclass.style         = 0;
	Aboutclass.lpfnWndProc   = (WNDPROC)AboutPopupWndProc;
	Aboutclass.cbClsExtra    = 0;
	Aboutclass.cbWndExtra    = 0;
	Aboutclass.hInstance     = hmodDLL;
	Aboutclass.hIcon         = NULL;
	Aboutclass.hCursor       = NULL;
	Aboutclass.hbrBackground = NULL;
	Aboutclass.lpszMenuName  = NULL;
	Aboutclass.lpszClassName = "AboutClass";  
	
	if (!RegisterClass(&Aboutclass))
		return FALSE;
    }
     
    if (usVersion < 0x0200) {
	EsColorclass.style         = 0;
	EsColorclass.lpfnWndProc   = (WNDPROC)ColorPopupWndProc;
	EsColorclass.cbClsExtra    = 0;
	EsColorclass.cbWndExtra    = 0;
	EsColorclass.hInstance     = hmodDLL;
	EsColorclass.hIcon         = NULL;
	EsColorclass.hCursor       = NULL;
	EsColorclass.hbrBackground = NULL;
	EsColorclass.lpszMenuName  = NULL;
	EsColorclass.lpszClassName = "EsColorClass";  
	
	if (!RegisterClass(&EsColorclass))
		return FALSE;  
		
	// We successfully initialized the stuff we need at dev time
	fDevTimeInited = TRUE;
		
    }                    
#endif // designtime dialogs

    // Register controls
    // * * * Push * * *
    if(!(rv = VBRegisterModel(hmodDLL, &modelHSlide)))
	return(rv);
      
    // registration done
	return rv;
}

//---------------------------------------------------------------------------
// Unregister custom control.  This routine is called by VB when the custom
// control DLL is being unloaded.
//---------------------------------------------------------------------------
VOID FAR PASCAL _export VBTERMCC
(
    VOID
)
{
    --cVbxUsers;
    if (0 == cVbxUsers && fDevTimeInited)
	{
		// Free any resources created for Dev environment
		UnregisterClass("AboutClass", hmodDLL);
		UnregisterClass("EsColorClass", hmodDLL);
	}
	    
	// Only if DLL is about to be unloaded    
	if (0 == cVbxUsers)
	{   
		// release bitmaps loaded for Slide
		DeleteObject(gSlideHScale);
		DeleteObject(gSlideHThumb);
		DeleteObject(gSlideHrightArrow);
		DeleteObject(gSlideHleftArrow);
	}
    return;
}

//---------------------------------------------------------------------------
// Initialize library.
//      This routine is called from the DLL entry point in LIBINIT.ASM
//      which is called when the first client loads the DLL.
//---------------------------------------------------------------------------

int FAR PASCAL LibMain(HANDLE hModule, WORD wDataSeg, WORD cbHeapSize, LPSTR  lpszCmdLine)
{
    int rv; // return value
    
    // Avoid warnings on unused (but required) formal parameters
    wDataSeg	= wDataSeg;
    cbHeapSize	= cbHeapSize;
    lpszCmdLine = lpszCmdLine;

    hmodDLL = hModule;
             
    // load bitmaps for horisontal slide
    rv = gSlideHScale = LoadBitmap(hmodDLL,MAKEINTRESOURCE(IDBMP_SLIDEHSCALE));
    rv = gSlideHThumb = LoadBitmap(hmodDLL, MAKEINTRESOURCE(IDBMP_SLIDEHBUTTON));
    rv = gSlideHrightArrow = LoadBitmap(hmodDLL, MAKEINTRESOURCE(IDBMP_ARROWRIGHT));
    rv = gSlideHleftArrow = LoadBitmap(hmodDLL, MAKEINTRESOURCE(IDBMP_ARROWLEFT)); 
    
    return rv;
}                      


// Changed 950118 AH !!!
// 		this code is now obsolete and has been moved to VBTERMCC
//
    
//---------------------------------------------------------------------------
// Handle exit notification from Windows.
//      This routine is called by Windows when the library is freed
//      by its last client.
//---------------------------------------------------------------------------
/*VOID FAR PASCAL _export WEP(BOOL fSystemExit)
{
    // Avoid warnings on unused (but required) formal parameters
    fSystemExit = fSystemExit;              

    // release bitmaps loaded for Slide
	DeleteObject(gSlideHScale);
	DeleteObject(gSlideHThumb);
	DeleteObject(gSlideHrightArrow);
	DeleteObject(gSlideHleftArrow);
}                       
*/

//---------------------------------------------------------------------------
// Provide custom control model information to host environment.
//---------------------------------------------------------------------------
LPMODELINFO FAR PASCAL _export VBGetModelInfo(USHORT usVersion)
{
	if (usVersion <= VB100_VERSION)
		return &modelinfoHSlide_Vb1;

    if (usVersion <= VB200_VERSION)
		return &modelinfoHSlide_Vb2;
    else
		return &modelinfoHSlide;
}      
//---------------------------------------------------------------------------
