//  ** Revision History **
//  15-Mar-1993 (AH) release 1.0.0.000
//  19-Sep-1992-1995 (AH) Problem with y-drift fixed
//  29-Aug-1992-1995 (AH) default Bitmap Load/unload moved to LibMain/WEP
//  22-Aug-1992-1995 (AH-EuroSource AB) Prehistory
//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         Hslide.c  (part of EuroHslide project)
//   
// PURPOSE:      Make a nice hslide window
//   
// COMMENTS:     
//   
//****************************************************************************                    


#define  NOCOMM
#include <windows.h>
#include <vbapi.h>
#include <string.h>
#include "eshslide.h"

#include "version.h"
#define  CTL_DATA       // To declare static data in hslide.h
#include "hslide.h" 
#include "vb1.h"		// Support for Visual Basic 1.0
#include "vb2.h"		// Support for Visual Basic 2.0
#include "helpid.h"

//---------------------------------------------------------------------------
// Global Variables
//---------------------------------------------------------------------------
BOOL    bHslideCaptured;  
HWND    ghWndhslide;                 // global window handle

// external declared             
extern HANDLE   hmodDLL;
extern WORD     ipropDialog;
extern HCTL     hctlDialog;      
extern HBITMAP  gslideHScale;
extern HBITMAP  gslideHThumb;
extern HBITMAP  gslideHrightArrow;
extern HBITMAP  gslideHleftArrow;

//---------------------------------------------------------------------------
// Local Prototypes
//---------------------------------------------------------------------------
VOID NEAR DrawHslide(HCTL hctl, HWND hWnd, HDC hDC);
VOID NEAR RecalcAreaHslide(HCTL hctl, HWND hWnd);

//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   LONG FAR PASCAL _export HslideCtlProc(HCTL hctl, HWND hwnd, USHORT msg, USHORT wp, LONG lp)       
//
//      PURPOSE:    Hslide Control Procedure     
//
//      COMMENTS:        
//
//**************************************************************************

LONG FAR PASCAL _export HslideCtlProc(HCTL hctl, HWND hWnd, USHORT msg, USHORT wp, LONG lp)
{
    LONG        lResult; 
    PHSLIDE       phslide;

    // Message pre-processing
    switch (msg) 
    {
	case WM_CREATE:
	    phslide = HSLIDEDEREF(hctl);                 
		phslide->Buttons = FALSE;               
	    phslide->BleftSelected = FALSE;
	    phslide->BrightSelected = FALSE;
	    phslide->Value = 0;
	    phslide->Min = 0;
	    phslide->Max = 32767;
	    phslide->SmallChange = 1;
	    phslide->LargeChange = 1;
	    phslide->ThumbWidth = 20; 
	    phslide->Track = FALSE;
	    
	    // assign default bitmaps                           
	    phslide->hbmpScale = gslideHScale;
	    phslide->hbmpThumb = gslideHThumb;  
	    phslide->hbmpleftArrow = gslideHleftArrow;
	    phslide->hbmprightArrow = gslideHrightArrow;

#ifndef RUNTIMEVERSION        	    
	    // set the property text for the About dialog
	    SetAboutText(hctl, IPROP_HSLIDE_ABOUT); 
#endif
        		    
	    VBSetControlProperty(hctl, IPROP_HSLIDE_BACKCOLOR, 
				       HSLIDE_BACKGROUND_DEFAULT);
	break;
	    
#ifndef RUNTIMEVERSION    
	case VBM_INITPROPPOPUP:
	switch (wp) {
	    case IPROP_HSLIDE_ABOUT:
		hctlDialog  = hctl;
		ipropDialog = wp;
		return (LONG)HwndInitAboutPopup();
	}
	break; 
#endif
    	
	case WM_ERASEBKGND:
	    // Don't bother with erasing the background
	    return TRUE;
		
	case WM_SETFOCUS:
	    break;
		    
	case WM_KILLFOCUS:
	    break;
	
	case WM_KEYDOWN: {
	    phslide = HSLIDEDEREF(hctl);
	    SetFocus(hWnd);
	    switch(wp) {
		case VK_PRIOR:          
		    phslide->Value -= phslide->LargeChange;
		    break;
		
		case VK_NEXT:                              
		    phslide->Value += phslide->LargeChange;
		    break;
		
		case VK_UP:                                
		    phslide->Value -= phslide->SmallChange;  
		    break;
		
		case VK_DOWN:       
		    phslide->Value += phslide->SmallChange;
		    break;        
	    }                                 
		// do some error checking
		if (phslide->Value > phslide->Max)
		phslide->Value = phslide->Max;
	    if (phslide->Value < phslide->Min)
		phslide->Value = phslide->Min; 
		SendMessage(hWnd, VBM_SETPROPERTY, IPROP_HSLIDE_VALUE, phslide->Value); 
	    SendMessage(hWnd, WM_PAINT, 0, 0L);
	    VBFireEvent(hctl, EVENT_HSLIDE_CHANGE, NULL);
	    }
	    return OK;

#ifndef RUNTIMEVERSION    		   
	case WM_RBUTTONDBLCLK: 
	    if (VBGetMode() == MODE_DESIGN) {
		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, eshslide);
		return OK;
	    }
	    else
		break;
#endif
    	
	case WM_LBUTTONDBLCLK:
	case WM_LBUTTONDOWN: {
	    POINT       pt;
			   
	    SetFocus(hWnd);
	    phslide = HSLIDEDEREF(hctl);
	    pt.x = LOWORD(lp);
		pt.y = HIWORD(lp);
	    if (phslide->Buttons) {
			if (PtInRect(&phslide->rectLeft, pt)) {
			SetCapture(hWnd);
			phslide->BleftSelected = TRUE;                
			InvalidateRect(hWnd, NULL, FALSE);
		}           
		if (PtInRect(&phslide->rectRight, pt)) {
			SetCapture(hWnd);
			phslide->BrightSelected = TRUE;                
			InvalidateRect(hWnd, NULL, FALSE);
		} 
	    }
	    if (PtInRect(&phslide->rectThumb, pt)) {
		SetCapture(hWnd);
		bHslideCaptured = TRUE;
		phslide->rightx = pt.x; // store y coordinate & diff
		phslide->dx = phslide->rectThumb.right-pt.x;
	    } 
	}
    
	// fall through

	case WM_MOUSEMOVE: {
	    POINT       pt; 
	    float               rp, Value;
	    PAINTSTRUCT ps; 
	    
	    phslide = HSLIDEDEREF(hctl);
	    pt.x = LOWORD(lp);
		pt.y = HIWORD(lp);
	    
		if (bHslideCaptured) {               
		pt.x += phslide->dx;
		if (pt.x <= phslide->rectDrawInto.right &&
		    pt.x >= phslide->rectDrawInto.left+phslide->ThumbWidth) {
				phslide->rectThumb.right = pt.x;
				phslide->rectThumb.left = pt.x-phslide->ThumbWidth;
				InvalidateRect(hWnd, NULL, FALSE);
		}         
		else { 
		    if (pt.x > phslide->rectDrawInto.left) {
			phslide->rectThumb.right = phslide->rectDrawInto.right;
				phslide->rectThumb.left = phslide->rectDrawInto.right-
											phslide->ThumbWidth;
				InvalidateRect(hWnd, NULL, FALSE);    
		    }                                                          
			if (pt.x < phslide->rectDrawInto.left+phslide->ThumbWidth) {
			phslide->rectThumb.left = phslide->rectDrawInto.left;
				phslide->rectThumb.right = phslide->rectDrawInto.left+phslide->ThumbWidth;
				InvalidateRect(hWnd, NULL, FALSE);    
		    } 
		}         
		BeginPaint(hWnd, &ps);
		DrawHslide(hctl, hWnd, ps.hdc);
		EndPaint(hWnd, &ps);
		// calculate value form position
		// =============================
		// if ZPos = rectDrawInto.top-ThumbWidth
		// then
		//              rectThumb.bottom-ZPos/
		//              rectDrawInto.bottom-rectDrawInto.top-ThumbWidth
		// give us the procentual position.
		// if we calculate this with
		//              (max-min) and add min
		// we receive the corrospnding value.
		
		rp = ((float)(phslide->rectThumb.right-phslide->rectDrawInto.left-phslide->ThumbWidth)/
			  (float)(phslide->rectDrawInto.right-phslide->rectDrawInto.left-phslide->ThumbWidth)); 
		Value = rp*(float)(phslide->Max-phslide->Min)+(float)phslide->Min;
		
		
		if ((SHORT)Value != phslide->Value && phslide->Track) {
		    phslide->Value = (SHORT)Value;
			// fire change event 
			VBFireEvent(hctl, EVENT_HSLIDE_CHANGE, NULL);
		}
		else
		    phslide->Value = (SHORT)Value;
	    } 
	
	    if (phslide->BleftSelected || phslide->BrightSelected) { 
			if (!PtInRect(&phslide->rectLeft, pt) &&
		    !PtInRect(&phslide->rectRight, pt)) {
				ReleaseCapture();
				phslide->BleftSelected = FALSE;
				phslide->BrightSelected = FALSE;
				InvalidateRect(hWnd, NULL, FALSE);
		}                                   
		}      
	    }
		break;

	case WM_LBUTTONUP: {
	    POINT   pt; 
	    phslide = HSLIDEDEREF(hctl); 
	    
			pt.x = LOWORD(lp);
			pt.y = HIWORD(lp);    
			// only react if buttons
			if (phslide->Buttons) {
				if (PtInRect(&phslide->rectLeft, pt)) {
					ReleaseCapture();
					phslide->BleftSelected = FALSE; 
			    phslide->Value -= phslide->SmallChange;
			    if (phslide->Value < phslide->Min)
				phslide->Value = phslide->Min;
					InvalidateRect(hWnd, NULL, FALSE);
			}       
		    else {
					ReleaseCapture();
					phslide->BrightSelected = FALSE; 
			    phslide->Value += phslide->SmallChange;
			    if (phslide->Value > phslide->Max)
				phslide->Value = phslide->Max;
					InvalidateRect(hWnd, NULL, FALSE);
			}               
			SendMessage(hWnd, VBM_SETPROPERTY, IPROP_HSLIDE_VALUE, phslide->Value);
			}
		if (bHslideCaptured) {
		    ReleaseCapture();
			bHslideCaptured = FALSE;
		    if (!phslide->Track)
				VBFireEvent(hctl, EVENT_HSLIDE_CHANGE, NULL);
		}    
	    }
		break;
	
	
	case WM_SIZE:
	    RecalcAreaHslide(hctl, hWnd);  
	    InvalidateRect(hWnd, NULL, TRUE);
	    break;

    case VBM_GETDEFSIZE:
            return MAKELONG(HSLIDE_DEFAULTWIDTH,HSLIDE_DEFAULTHEIGHT);    	    
        
	case WM_PAINT:
	    if (wp)
		DrawHslide(hctl, hWnd, (HDC)(wp));
	    else {
		PAINTSTRUCT     ps;

		BeginPaint(hWnd, &ps);
		DrawHslide(hctl, hWnd, ps.hdc);
		EndPaint(hWnd, &ps);
	    }
	    break;

    
#ifndef RUNTIMEVERSION    
	case VBM_HELP:
	    switch (LOBYTE(wp))
		{
			case VBHELP_PROP:
		    	// High byte identifies which property.
		    	// Keyword is: "<property>"
		    	switch (HIBYTE(wp))
				{
					case IPROP_HSLIDE_ABOUT:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_about);
			    		return OK;

					case IPROP_HSLIDE_BUTTONS:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_buttons);
			    		return 0L;                                                        
                
            		case IPROP_HSLIDE_LARGECHANGE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_largechange);
			    		return 0L;                                            
            
            		case IPROP_HSLIDE_MAX:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_max);
			    		return 0L;                                            
            
            		case IPROP_HSLIDE_MIN:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_min);
			    		return 0L;                                       
            
            		case IPROP_HSLIDE_PICTURESCALE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_picturescale);
			    		return 0L;                                      
            
            		case IPROP_HSLIDE_PICTURETHUMB:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_picturethumb);
			    		return 0L;                                             
            
                	case IPROP_HSLIDE_SMALLCHANGE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_smallchange);
			    		return 0L;                                            
                     
                	case IPROP_HSLIDE_TRACK:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_track);
			    		return 0L;                                      
                                                                             
                	case IPROP_HSLIDE_VALUE:
			    		WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, property_value);
			    		return 0L;
				}
				break;

		case VBHELP_CTL:
		    // High byte is unused.
		    // Keyword is: "<classname>"
		    WinHelp(hWnd, "BUTTONS.HLP", HELP_CONTEXT, eshslide);
		    return 0L;
	}
	break;                        
#endif
        	    
	case VBM_SETPROPERTY:
	    switch (wp) {
		case IPROP_HSLIDE_BUTTONS:
		    RecalcAreaHslide(hctl, hWnd);
		    InvalidateRect(hWnd, NULL, TRUE);
		    return(0L);
		
		case IPROP_HSLIDE_VALUE: {
		    phslide = HSLIDEDEREF(hctl);
		    phslide->rectThumb.right = (SHORT)(((float)phslide->Value/(float)(phslide->Max-phslide->Min))*
		    (phslide->rectDrawInto.right-phslide->rectDrawInto.left-phslide->ThumbWidth)+
		    (phslide->rectDrawInto.left+phslide->ThumbWidth));
		    phslide->rectThumb.left = phslide->rectThumb.right-phslide->ThumbWidth;
		    VBFireEvent(hctl, EVENT_HSLIDE_CHANGE, NULL);
			InvalidateRect(hWnd, NULL, TRUE);
		}
		return (OK);
		    
		case IPROP_HSLIDE_MIN:
		case IPROP_HSLIDE_MAX:                  
		    InvalidateRect(hWnd, NULL, TRUE);
		    return(0L);
	    }
	    break;

	case VBM_GETPROPERTY: {
	    phslide = HSLIDEDEREF(hctl);
	
	    if (wp == IPROP_HSLIDE_HWND) { 
		ghWndhslide = VBGetControlHwnd(hctl);
		(HWND *)lp = &ghWndhslide; 
		return OK;
	    }   
		break; 
	}
	
	case VBM_CHECKPROPERTY: {
	    phslide = HSLIDEDEREF(hctl);
	    
	    switch (wp) {
		case IPROP_HSLIDE_VALUE: 
		    if ((SHORT)lp > 32767 || 
			(SHORT)lp > phslide->Max ||
			(SHORT)lp < phslide->Min)
				return ERR_InvPropVal;
		    break;        
		
		case IPROP_HSLIDE_MIN:
		    if ((SHORT)lp < -32768 ||
			(SHORT)lp > 32767)
				return ERR_InvPropVal;
		    break;        
		
		case IPROP_HSLIDE_MAX:
		    if ((SHORT)lp < -32768 ||
			(SHORT)lp > 32767)
				return ERR_InvPropVal;
		    break;        
		
		case IPROP_HSLIDE_SMALLCHANGE:
		    if ((SHORT)lp < 0)
			return ERR_InvPropVal;
		    break;
		    
		case IPROP_HSLIDE_LARGECHANGE:
		    if ((SHORT)lp < 0)
			return ERR_InvPropVal;  
		    break;
		    
		case IPROP_HSLIDE_PICTURESCALE: {
		    PIC pic;

			VBGetPic((HPIC)lp, &pic);
		    phslide = HSLIDEDEREF(hctl);
		    
			switch (pic.picType) {
				case PICTYPE_NONE:  
			    phslide->hbmpScale = gslideHScale;
			    InvalidateRect(hWnd, NULL, TRUE);
				return ERR_None;
			
				case PICTYPE_BITMAP:  
				phslide->hbmpScale = pic.picData.bmp.hbitmap;
				InvalidateRect(hWnd, NULL, TRUE);
				return ERR_None;
			}
			return ERR_InvPropVal;
		}
		break;
	    
		case IPROP_HSLIDE_PICTURETHUMB: {
		    PIC pic;

			VBGetPic((HPIC)lp, &pic);
		    phslide = HSLIDEDEREF(hctl);
		    
			switch (pic.picType) {
				case PICTYPE_NONE:  
			    phslide->hbmpThumb = gslideHThumb;
			    InvalidateRect(hWnd, NULL, TRUE);
				return ERR_None;
			
				case PICTYPE_BITMAP:  
				phslide->hbmpThumb = pic.picData.bmp.hbitmap;
				InvalidateRect(hWnd, NULL, TRUE);
				return ERR_None;
			}
			return ERR_InvPropVal;
		}
		break;                              
	    }                    
		}
		return ERR_None;
	    break;
    }

    // Default processing:
    lResult = VBDefControlProc(hctl, hWnd, msg, wp, lp);

    // Message post-processing:
    switch (msg) {
	case WM_DESTROY: {
	    // release hslide picture
	    phslide = HSLIDEDEREF(hctl);
	    // release VB picture structures all other
	    // bitmaps are released in WEP
	    VBFreePic(HSLIDEDEREF(hctl)->hPicScale);
	    VBFreePic(HSLIDEDEREF(hctl)->hPicThumb);       
	    break;
	}
    }
    return lResult;
}


//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR DrawHslide(HCTL hctl, HWND hWnd, HDC hDC)       
//
//      PURPOSE:    Draw the Hslide     
//
//      COMMENTS:        
//
//      HISTORY:    920525AH Prehistory     
//
//**************************************************************************

VOID NEAR DrawHslide(HCTL hctl, HWND hWnd, HDC hDC)
{
    PHSLIDE  phslide = HSLIDEDEREF(hctl);
    HBRUSH      hBrush;
    HDC         hdcMem, hdcArrow, hdcScale, hdcThumb;
    RECT        rcClient;
    HBITMAP     hbmp, hbmpOld,hArrowOld,hThumbOld, hScaleOld;
    BITMAP      bmp;
    int         x,y,scaleoffset;
		     
    GetClientRect(hWnd, &rcClient);
    hBrush = (HBRUSH)SendMessage(GetParent(hWnd), WM_CTLCOLOR, hDC, MAKELONG(hWnd, 0));
    
	hdcMem = CreateCompatibleDC(hDC);
    hbmp = CreateCompatibleBitmap(hDC, rcClient.right-rcClient.left,
								  rcClient.bottom-rcClient.top);
    
    if (hbmp == NULL || hdcMem == NULL)
	return;
    
    hbmpOld = SelectObject(hdcMem, hbmp);
    
    //Fill Background
    FillRect(hdcMem, &rcClient, hBrush);
    
    if (phslide->Buttons) {
	// handle upper button
	if (phslide->BleftSelected)
		DrawButton(hdcMem, &phslide->rectLeft, DARKGREY, WHITE);
	else
	    DrawButton(hdcMem, &phslide->rectLeft, WHITE, DARKGREY);
	 
	// handle lower button
	if (phslide->BrightSelected)
		DrawButton(hdcMem, &phslide->rectRight, DARKGREY, WHITE);
	else
	    DrawButton(hdcMem, &phslide->rectRight, WHITE, DARKGREY);
	
	// now draw the arrows starting with the upper
	hdcArrow = CreateCompatibleDC(hDC);
	GetObject(phslide->hbmpleftArrow, sizeof(BITMAP), (LPSTR)&bmp);
	x = (phslide->rectLeft.right-phslide->rectLeft.left-bmp.bmWidth) / 2 + phslide->rectLeft.left;
	y = (phslide->rectLeft.bottom-phslide->rectLeft.top-bmp.bmHeight) /2 + phslide->rectLeft.top;
	hArrowOld = SelectObject(hdcArrow, phslide->hbmpleftArrow);
	BitBlt(hdcMem, x, y,
		phslide->rectLeft.right - phslide->rectLeft.left-4,
		phslide->rectLeft.bottom - phslide->rectLeft.top-4,
		hdcArrow, 0, 0, /*bmp.bmWidth, bmp.bmHeight,*/
		SRCCOPY);
	SelectObject(hdcArrow, hArrowOld);  
	DeleteDC(hdcArrow); 
	// and the lower....
	hdcArrow = CreateCompatibleDC(hDC);
	GetObject(phslide->hbmprightArrow, sizeof(BITMAP), (LPSTR)&bmp);
	x = (phslide->rectRight.right-phslide->rectRight.left-bmp.bmWidth) / 2 + phslide->rectRight.left;
	y = (phslide->rectRight.bottom-phslide->rectRight.top-bmp.bmHeight) /2 + phslide->rectRight.top;
	hArrowOld = SelectObject(hdcArrow, phslide->hbmprightArrow);
	BitBlt(hdcMem, x, y,
		phslide->rectRight.right - phslide->rectRight.left-4,
		phslide->rectRight.bottom - phslide->rectRight.top-4,
		hdcArrow, 0, 0, 
		SRCCOPY);  
	SelectObject(hdcArrow, hArrowOld);
	DeleteDC(hdcArrow);
    }
    
    // blit the scale to the memory DC
    scaleoffset = 0;
    hdcScale = CreateCompatibleDC(hDC);
    
    GetObject(phslide->hbmpScale, sizeof(BITMAP), (LPSTR)&bmp);
    x = (phslide->rectDrawInto.right-phslide->rectDrawInto.left-bmp.bmWidth) / 2 + phslide->rectDrawInto.left;
    y = (phslide->rectDrawInto.bottom-phslide->rectDrawInto.top-bmp.bmHeight) /2 + phslide->rectDrawInto.top;
    hScaleOld=SelectObject(hdcScale, phslide->hbmpScale);  
    
    // don't draw over right button                 
    if (phslide->Buttons) {
	ExcludeClipRect(hdcMem,         phslide->rectRight.left,
								phslide->rectRight.top,
								phslide->rectRight.right,
								phslide->rectRight.bottom);
    }   

    while (scaleoffset < phslide->rectDrawInto.right) {
	BitBlt(hdcMem,                                
			phslide->rectDrawInto.left+scaleoffset,         
			y,
			phslide->rectDrawInto.right - phslide->rectDrawInto.left,
			phslide->rectDrawInto.bottom - phslide->rectDrawInto.top,
			hdcScale,
			0, 0,
			SRCCOPY);
			scaleoffset += bmp.bmWidth; 
    }      
	SelectObject(hdcScale, hScaleOld);
    DeleteDC(hdcScale);
	
    // Draw the thumb-bar into the memory DC
    hdcThumb = CreateCompatibleDC(hDC);
    GetObject(phslide->hbmpThumb, sizeof(BITMAP), (LPSTR)&bmp);
    x = (phslide->rectThumb.right-phslide->rectThumb.left-bmp.bmWidth) / 2 + phslide->rectThumb.left;
    y = (phslide->rectThumb.bottom-phslide->rectThumb.top-bmp.bmHeight) /2 + phslide->rectThumb.top;
    hThumbOld = SelectObject(hdcThumb, phslide->hbmpThumb);
    BitBlt(hdcMem, phslide->rectThumb.left, y,
		phslide->rectThumb.right - phslide->rectThumb.left,
		phslide->rectThumb.bottom - phslide->rectThumb.top,
		hdcThumb, 0, 0,
		SRCCOPY);
    SelectObject(hdcThumb,hThumbOld);
    DeleteDC(hdcThumb); 
	      
    // blit offscreen dc stuff to the screen dc
    BitBlt(hDC,                                
		rcClient.left,
		rcClient.top,
		rcClient.right-rcClient.left,
		rcClient.bottom-rcClient.top,
		hdcMem,
		0, 0,
		SRCCOPY);
    
    SelectObject(hdcMem, hbmpOld);
    // no need to delete hBrush (VB rescurce)
    DeleteObject(hbmp);
	DeleteDC(hdcMem);
}


//**************************************************************************
//                        Copyright (C) 1992-1995 EuroSource AB
//
//      FUNCTION:   VOID NEAR RecalcAreaHslide(HCTL hctl, HWND hWnd);      
//
//      PURPOSE:    Use the hWnd's client size to determine the bounding 
//                  rectangle for the framepicture and associated stuff.     
//
//      COMMENTS:        
//
//      HISTORY:    920526AH Prehistory     
//
//**************************************************************************


VOID NEAR RecalcAreaHslide(HCTL hctl, HWND hWnd)
{
    PHSLIDE   phslide = HSLIDEDEREF(hctl);
    LPRECT  prectHslide = &phslide->rectDrawInto;
    LPRECT  prectLeft = &phslide->rectLeft;
    LPRECT  prectRight = &phslide->rectRight;
    LPRECT  prectThumb = &phslide->rectThumb;
    RECT    rectAll;
    
    // get the clientarea
    GetClientRect(hWnd, &rectAll);
    
    // calculate hslide rectangle
    prectHslide->left = rectAll.left;
    prectHslide->top =  rectAll.top;
    prectHslide->right = rectAll.right;
    prectHslide->bottom = rectAll.bottom;    
    
	if (phslide->Buttons) { 
	// calculate left button rectangle
	prectLeft->left = rectAll.left; 
	prectLeft->top = rectAll.top;
	prectLeft->right = rectAll.left+20;
	prectLeft->bottom = rectAll.bottom;               
	
	// calculate right button rectangle
	prectRight->left = rectAll.right-20;
	prectRight->top = rectAll.top;
	prectRight->right = rectAll.right;
	prectRight->bottom = rectAll.bottom;
	
	// calculate hslide rectangle
	prectHslide->left = rectAll.left+21;
	prectHslide->right = rectAll.right-20;
    }                         
    // calculate the Thumb rectangle
    prectThumb->left = prectHslide->left;
    prectThumb->top =   prectHslide->top;
    prectThumb->right = prectHslide->left+20;
    prectThumb->bottom = prectHslide->bottom;
}    
