//****************************************************************************
//                    Copyright (C) 1992-1995 EuroSource AB
//
// FILE:         hslide.h
//   
// PURPOSE:      Header file for HSLIDE subclass EuroCtrl project
//   
// COMMENTS:     
//   
//****************************************************************************                    



#define HSLIDE_BACKGROUND_DEFAULT    GREY

#define HSLIDE_DEFAULTWIDTH		100
#define HSLIDE_DEFAULTHEIGHT    30 

//---------------------------------------------------------------------------
// HSLIDE control data and structs
//---------------------------------------------------------------------------
typedef struct tagHSLIDE
{                     
    HSZ		hszabout;
    RECT	rectDrawInto;	// rectangle for hslide
    RECT	rectLeft;		// rect for upper button
    RECT	rectRight;		// rect for lower button
    RECT	rectThumb;		// moving thump rectangle
    BOOL	Buttons;		// TRUE if buttons 
    BOOL	BleftSelected;	// TRUE if upper button selected
    BOOL	BrightSelected;	// TRUE if lower button selected
    HBITMAP	hbmpleftArrow;	// upper arrow bitmap
    HBITMAP hbmprightArrow;	// lower arrow bitmap
    HBITMAP hbmpScale;		// scale bitmap 
    HBITMAP hbmpThumb;		// Thumb bitmap
    SHORT	Value;			// current value
    SHORT	Min;			// minimum value
    SHORT	Max;			// maximun value
    SHORT	SmallChange;	// Smallchange on buttons
    SHORT	LargeChange;	// Largechange on area for instance
    SHORT	rightx;			// y coordinate when thumb selected
    SHORT	dx;				// distance between thumb bottom and *rightx*
	HPIC	hPicScale;		// user defined Scale
	HPIC	hPicThumb;		// user defines Thumb
	SHORT	ThumbWidth;		// Width for Thumb picture
	BOOL	Track;			// TRUE if Change event generated during mouse move
} HSLIDE;

typedef HSLIDE FAR * PHSLIDE;

#define HSLIDEDEREF(hctl)     ((PHSLIDE)VBDerefControl(hctl))

//---------------------------------------------------------------------------
// Control Procedure
//---------------------------------------------------------------------------
LONG FAR PASCAL _export HslideCtlProc(HCTL, HWND, USHORT, USHORT, LONG);


#ifndef RC_INVOKED
//---------------------------------------------------------------------------
// Property list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the properties
//---------------------------------------------------------------------------
#define IPROP_HSLIDE_NAME            	0
#define IPROP_HSLIDE_INDEX          	1
#define IPROP_HSLIDE_PARENT          	2
#define IPROP_HSLIDE_BACKCOLOR       	3
#define IPROP_HSLIDE_LEFT            	4
#define IPROP_HSLIDE_TOP             	5
#define IPROP_HSLIDE_WIDTH           	6
#define IPROP_HSLIDE_HEIGHT          	7
#define IPROP_HSLIDE_ENABLED         	8
#define IPROP_HSLIDE_VISIBLE         	9
#define IPROP_HSLIDE_MOUSEPOINTER    	10
#define IPROP_HSLIDE_DRAG            	11
#define IPROP_HSLIDE_DRAGICON        	12
#define IPROP_HSLIDE_TABINDEX        	13
#define IPROP_HSLIDE_TABSTOP         	14
#define IPROP_HSLIDE_TAG             	15
#define IPROP_HSLIDE_FORECOLOR       	16
#define IPROP_HSLIDE_ABOUT				17
#define IPROP_HSLIDE_BUTTONS			18
#define IPROP_HSLIDE_VALUE				19
#define IPROP_HSLIDE_MIN				20
#define IPROP_HSLIDE_MAX				21
#define IPROP_HSLIDE_SMALLCHANGE		22
#define IPROP_HSLIDE_LARGECHANGE		23
#define IPROP_HSLIDE_PICTURESCALE		24
#define IPROP_HSLIDE_PICTURETHUMB		25
#define IPROP_HSLIDE_TRACK				26
#define IPROP_HSLIDE_HWND				27
#ifdef CTL_DATA                       

PROPINFO Property_hslide_About =
{
    "About...",
    DT_HSZ | PF_fGetData | PF_fSetData | PF_fEditable,
    OFFSETIN(HSLIDE, hszabout)
}; 


PROPINFO propinfohslideButtons =
{
    "Buttons",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(HSLIDE,Buttons), 0,
	FALSE
};

PROPINFO propinfohslideValue =
{
    "Value",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(HSLIDE,Value), 0,
	0
};                      

PROPINFO propinfohslideMin =
{
    "Min",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(HSLIDE,Min), 0,
	0
};
        
PROPINFO propinfohslideMax =
{
    "Max",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetCheck | PF_fSetData | PF_fSaveData  | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(HSLIDE,Max), 0,
	32767
};

PROPINFO propinfohslideSmallChange =
{
    "SmallChange",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(HSLIDE,SmallChange), 0,
	1
};  

PROPINFO propinfohslideLargeChange =
{
    "LargeChange",
    DT_SHORT | PF_fGetData | PF_fSetMsg | PF_fSetCheck | PF_fSetData | PF_fSaveData  | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(HSLIDE,LargeChange), 0,
	1
};

PROPINFO propinfohslidePictureScale =
{
    "PictureScale",
    DT_PICTURE | PF_fGetData | PF_fSetMsg | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(HSLIDE,hPicScale), 0,
	0
};

PROPINFO propinfohslidePictureThumb =
{
    "PictureThumb",
    DT_PICTURE | PF_fGetData | PF_fSetMsg | PF_fSetCheck | PF_fSetData | PF_fSaveData | PF_fDefVal,
    OFFSETIN(HSLIDE,hPicThumb), 0, 
	0
};    

PROPINFO propinfohslideTrack =
{
    "Track",
    DT_BOOL | PF_fGetData | PF_fSetMsg | PF_fSetData | PF_fSaveData | PF_fDefVal | PF_fNoInitDef,
    OFFSETIN(HSLIDE,Track), 0, 
	FALSE
};

PROPINFO propinfohslidehWnd =
{
    "hWnd",
    DT_SHORT | PF_fGetMsg | PF_fNoShow | PF_fNoRuntimeW,
    0, 0
};

PPROPINFO proplistHslide[] =
{
    PPROPINFO_STD_CTLNAME,
    PPROPINFO_STD_INDEX,
    PPROPINFO_STD_PARENT,
    PPROPINFO_STD_BACKCOLOR,
    PPROPINFO_STD_LEFT,
    PPROPINFO_STD_TOP,
    PPROPINFO_STD_WIDTH,
    PPROPINFO_STD_HEIGHT,
    PPROPINFO_STD_ENABLED,
    PPROPINFO_STD_VISIBLE,
    PPROPINFO_STD_MOUSEPOINTER,
    PPROPINFO_STD_DRAGMODE,
    PPROPINFO_STD_DRAGICON,
    PPROPINFO_STD_TABINDEX,
    PPROPINFO_STD_TABSTOP,
    PPROPINFO_STD_TAG,
    PPROPINFO_STD_FORECOLOR,
    &Property_hslide_About,
    &propinfohslideButtons,
    &propinfohslideValue,
    &propinfohslideMin,
    &propinfohslideMax,
    &propinfohslideSmallChange,
    &propinfohslideLargeChange,
    &propinfohslidePictureScale,
    &propinfohslidePictureThumb,
    &propinfohslideTrack,
    &propinfohslidehWnd,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Event list
//---------------------------------------------------------------------------
// Define the consecutive indicies for the events
//---------------------------------------------------------------------------
EVENTINFO Event_Change_Hslide =
{
    "Change",
    0,
    0,
    NULL,
    NULL
};
                            
#define EVENT_HSLIDE_CHANGE		 0
#define EVENT_HSLIDE_DRAGDROP    1
#define EVENT_HSLIDE_DRAGOVER    2
      
#ifdef CTL_DATA
PEVENTINFO eventlistHslide[] =
{                                
    &Event_Change_Hslide,
    PEVENTINFO_STD_DRAGDROP,
    PEVENTINFO_STD_DRAGOVER,
    NULL
};
#endif  // CTL_DATA


//---------------------------------------------------------------------------
// Model struct
//---------------------------------------------------------------------------
// Define the control model (using the event and property structures).
//---------------------------------------------------------------------------
#ifdef CTL_DATA
MODEL modelHslide =
{
    VB_VERSION,                 // VB version being used
    MODEL_fFocusOk | MODEL_fArrows |             // MODEL flags
    MODEL_fDesInteract,          				
    (PCTLPROC)HslideCtlProc,    // Control procedure
    CS_VREDRAW | CS_HREDRAW |   // Class style
    CS_BYTEALIGNWINDOW,
    NULL,                 		// Default Window style
    sizeof(HSLIDE),             // cbCtlExtra for HSLIDE structure
    IDBMP_HSLIDE,               // Palette bitmap ID
    "EsHSlide",		            // Default control name
    "EsHSlide",		            // Visual Basic class name
    NULL,                   	// Parent class name
    proplistHslide,             // Properties list
    eventlistHslide,            // Events list
	IPROP_HSLIDE_LARGECHANGE,	// Default property
	EVENT_HSLIDE_CHANGE,		// Default event
	IPROP_HSLIDE_VALUE,			// Standard property
};
#endif  // CTL_DATA

LPMODEL modellistHslide[] =
    {
    &modelHslide,
    NULL
    };

MODELINFO modelinfoHslide =
    {
    VB_VERSION, 			// VB version being used
    modellistHslide			// MODEL list
    };


#endif  // RC_INVOKED
